function K_Group(n_group, species_name, ouput_directory)
%%%function K_Group(n_group, species_name)
%%% Kenneth 03_12_09 
%%% to group sub-species with >= n_group speciments
%%% updated by Kenneth 11_09_09

%%disp('SPECIES_NAME')
%%disp(species_name)

%% get the names of species
load K_Sqns.mat;
Sub_Name = cell(N,1);
for i=1:N
    Tmp_Name = Names{i};
    Inx = find(Tmp_Name=='|');
    Sub_Name{i} = Tmp_Name((Inx(species_name-1)+1):(Inx(species_name)-1));
end

%disp(Names);
%Names_Size = numel(Names);
%disp(Names_Size);
%disp(Sub_Name)
%% define the training and test sets for n_group (rewrite by Kenneth
% 11_09_09)

% first go over all the species
Indx_Group_All = ones(N,1);
for i=1:N-1
    if strcmp(Sub_Name{i}, Sub_Name{i+1})
        Indx_Group_All(i+1)=Indx_Group_All(i);
    else
        Indx_Group_All(i+1)=Indx_Group_All(i)+1;
    end
end

%disp(Indx_Group_All)

%% Construct Structure Matrix Key 
Sub_Name_Size = numel(Sub_Name);
Indx_Group_All_Size = numel(Indx_Group_All);
Names_Size = numel(Names);
%disp(Sub_Name_Size)
%disp(Indx_Group_All_Size)
disp(Names_Size);
key_file_location = [ouput_directory, '/klee_key.txt'];
fid_klee_key = fopen(key_file_location, 'w');

%for j=1:Sub_Name_Size
%    Sub_Name_Curr = Sub_Name{j};
%    Indx_Group_All_Curr = Indx_Group_All(j);

%    str2screen = [ num2str(Indx_Group_All_Curr), ' : ', num2str(Sub_Name_Curr)];
%    str2file = [ num2str(Indx_Group_All_Curr), ' : ', num2str(Sub_Name_Curr), '\n'];
    
%    %2 DIFFERENT WAYS OF CREATIG THE KEY FILE...
    
%    %str2screen = [ num2str(j), ' : ', num2str(Sub_Name_Curr)];
%    %str2file = [ num2str(j), ' : ', num2str(Sub_Name_Curr), '\n'];

%    disp(str2screen);
%    fprintf(fid_klee_key, str2file);
%    
%    j = j+1;
%end

for j=1:Names_Size
    Names_Curr = Names{j};
    Indx_Group_All_Curr = Indx_Group_All(j);

    str2screen = [ num2str(Indx_Group_All_Curr), ' : ', num2str(Names_Curr)];
    str2file = [ num2str(Indx_Group_All_Curr), ' : ', num2str(Names_Curr), '\n'];
    
    %2 DIFFERENT WAYS OF CREATING THE KEY FILE...
    
    %str2screen = [ num2str(j), ' : ', num2str(Names_Curr)];
    %str2file = [ num2str(j), ' : ', num2str(Names_Curr), '\n'];

    disp(str2screen);
    fprintf(fid_klee_key, str2file);
    
    j = j+1;
end

fclose(fid_klee_key);
    
% then define training and test sets
I_Group = 1;
Indx_Group = [];
Indx_Group_test = [];
for k=1:N
    Ind_k = find(Indx_Group_All==k);
    Len_k = length(Ind_k); 
    if Len_k >= n_group
        Indx_Group = [Indx_Group; Ind_k(1:n_group) I_Group*ones(n_group,1)];
        Indx_Group_test = [Indx_Group_test; Ind_k((n_group+1):end) I_Group*ones(Len_k-n_group,1)];       
        I_Group = I_Group+1;
    end
end


%% save the result
filename = strcat('K_Group',num2str(n_group),'.mat');
save(filename, 'Sub_Name', 'N', 'Indx_Group_All', 'Indx_Group', 'Indx_Group_test');



