function K_Main()

%%% By Kenneth 03_12_09
%%% Implement analysis and prediction for species groups

%% Step 0 - Initialization
dbstop if error
clear all
clc
tic
format compact

%%%%%%%%%%%%%%% USER-DEFINED VARIABLES %%%%%%%%%%%%%%%%%%%%
DataFile = 'gavia.fas'; % Default input file
Species_Name = 3 % The position of the species name indicated in the .fas file
n_group = 1 % Each species includes n-group number of sequences per species
Sequence_Start = 100 % Start reading from the base pair in this position
Sequence_End = 600 % End reading from the base pair in this position
Ouput_Directory = '/Your/Output/Directory/'; % Location on local computer where output will be written.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Step 1 - Read sequences from the fas file into the mat file
disp('Step 1 - Read sequences from the fas file into the mat file')
K_ReadBarCode(DataFile)

%% Step 2 - Translate the seqences into binary vectors
disp('Step 2 - Translate the seqences into binary vectors')
K_ConvertBarCode(Sequence_Start, Sequence_End)

%% Step 3 - Group all the species & fill in the blanks with the modes 
% Each group contains 'n_group' sequences for computing the indicator vectors
disp('Step 3 - Group all the species & fill in the blanks with the modes') 
K_Group(n_group, Species_Name, Ouput_Directory)
%K_Group(n_group, Species_Name)
K_FillN(n_group)

%% Step 4 - Construct the Indicator Vectors
disp('Step 4 - Construct the Indicator Vectors')
Is_Emp = K_Vector(n_group);
if Is_Emp==1
    return
end

%% Step 5 - Predict the sequences in the test set
disp('Step 5 - Predict the sequences in the test set')
K_Predict(n_group)

toc
