function K_Predict(n_group)
%%% Kenneth 03_13_09
%%% predict the test group based on the correlations between the test
%%% group and the indicator vectors

%% load mat files
load K_SqnsN.mat

file2 = strcat('K_Group',num2str(n_group),'.mat');
file3 = strcat('K_Vector_Group',num2str(n_group),'.mat');
load(file2)
load(file3)

%% check if the test set is empty
if isempty(Indx_Group_test)==1
    disp('The test set is empty.')
    return
end

%% construct the test sequences
N_base=size(V,2);
N_test=size(Indx_Group_test,1);
Sqns_Test=SqnsN(Indx_Group_test(:,1),:);

%% calculate the correlations
Inner_Test=Sqns_Test*V/sqrt(Len);

%% show the prediction matrix
figure
imagesc(Inner_Test);
title('Prediction Matrix');
colorbar;

%% compute the correction rate
[N M]=size(Inner_Test);
Max=zeros(N,1);
I_max=zeros(N,1);
V_Correct=zeros(N,1); % 1 means correct, 0 means incorrect

for i=1:N
    [Max(i),I_max(i)]=max(Inner_Test(i,:));
%     if Ind_sort(I_max(i))==Indx_Group_test_sort(i,2)
    if I_max(i)==Indx_Group_test(i,2)
        V_Correct(i)=1;
    end        
end
Correct_Rate=sum(V_Correct)/N

%% save the result
file4 = strcat('K_Predict_Group',num2str(n_group),'.mat');
save(file4, 'Max', 'I_max', 'Inner_Test', 'V_Correct', 'Correct_Rate');