function [SqnsN, FlagN, N_emp] = K_TranslateBar(Sqn)

%%% Kenneth 03_12_09
%%% this function is to convert the barcode sequence matrix Sqn (M x Len)
%%% into a M x (4*Len) matrix SqnNs. N_emp is the number of blanks

%%% A=[1;0;0;0];
%%% C=[0;1;0;0];
%%% G=[0;0;1;0];
%%% T=[0;0;0;1];
%%% N = - = [0,0,0,0];

%% Initialization
[M,Len] = size(Sqn);
SqnsN = zeros(M, 4*Len);
N_emp = zeros(M, 1); %number of blanks
FlagN = zeros(M, Len); 
% flags for calculating the mode of each row 1-A ,2-C, 3-G, 4-T, 5-'-', 0-N

%% translate all the sequences into SqnsN and FlagN 
for i=1:M
    Mtmp=zeros(4, Len);
    for j=1:Len
        if  Sqn(i,j)=='A'
            Mtmp(:,j)=[1 0 0 0]';
            FlagN(i,j)=1;
        elseif Sqn(i,j)=='C'
            Mtmp(:,j)=[0 1 0 0]';
            FlagN(i,j)=2;
        elseif Sqn(i,j)=='G'
            Mtmp(:,j)=[0 0 1 0]';
            FlagN(i,j)=3;
        elseif Sqn(i,j)=='T'
            Mtmp(:,j)=[0 0 0 1]';
            FlagN(i,j)=4;
        elseif Sqn(i,j)=='-'
            Mtmp(:,j)=[0 0 0 0]';
            FlagN(i,j)=5;
        elseif Sqn(i,j)=='N'
            FlagN(i,j)=0;
            N_emp(i)=N_emp(i)+1;
        end
    end
    SqnsN(i,:)=reshape(Mtmp,4*Len,1)';
end





