function Is_Emp = K_Vector(n_group)
%%% Kenneth 03_13_09
%%% compute the indicator vectors and the structure matrix

%% load the data files
file1 = strcat('K_SqnsN_FillN',num2str(n_group),'.mat');
file2 = strcat('K_Group',num2str(n_group),'.mat');
load(file1)
load(file2)
Is_Emp=0;

%% Check if the training set is empty
if isempty(Indx_Group)==1
    disp('The training set is empty.')
    Is_Emp=1;
    return
end

%% compute the indicator vector for each group (3 sequences)
Sqns_Group=SqnsN(Indx_Group(:,1), :); %each row is a sequence
Num = size(Indx_Group,1);
S_Sum=zeros(Len*4,Len*4);
V=zeros(Len*4,Num/n_group);
D=zeros(Num/n_group,1);

for i=1:n_group:Num
    S_Sum=S_Sum+Sqns_Group(i:i+n_group-1,:)'*Sqns_Group(i:i+n_group-1,:);
end

k=1;
for i=1:n_group:Num
    S = Sqns_Group(i:i+n_group-1,:)'*Sqns_Group(i:i+n_group-1,:);
    opt.disp = 0;
    [V(:,k) D(k)] = eigs(S-1/(Num/n_group-1)*(S_Sum-S),1,'la',opt);
    k=k+1;
end
V=-V;

%% construct the structure matrix
InnerV=V'*V;


%% show the structure matrix
figure
j = imagesc(InnerV)
title('Structure Matrix')
caxis([0.25 1])
colorbar;

%% save the result
%saveas(j,'fig6.jpg','jpg');
%saveas(j,'fig7.tif','tif');
%saveas(j,'fig8.fig','fig');

h = gcf;
%%saveas(h,'fig1.bmp','bmp');
saveas(h,'fig2.jpg','jpg');
saveas(h,'fig3.tif','tif');
saveas(h,'fig4.fig','fig');

file3 = strcat('K_Vector_Group',num2str(n_group),'.mat');
save(file3,'V', 'D', 'Num', 'Len', 'S_Sum', 'InnerV');
